indexing

	description: "Main service application and callbacks. Dispatch to individual services."


class

	SERVICE_APPLICATION


inherit

	ANY

	SERVICE_DEBUGGING
		export
			{NONE} all
		end

-- 	WEL_APPLICATION
-- 		rename
-- 			make as make_application
-- 		redefine
-- 			run
-- 		end

	WINSVC_FUNCTIONS_EXTERNAL
		export
			{NONE} all
		end

	MEMORY
		export
			{NONE} all
		end

	LPSERVICE_MAIN_FUNCTIONA_CALLBACK
		rename
			on_callback as service_main
		end


creation

	make

feature {NONE} -- Initialization

	make is
		local
			service_table: SERVICE_TABLE_ENTRYA_ARRAY
		do
			-- No gc for now
			--collection_off
			create {EXAMPLE_SERVICE} service.make
			create callback.make (Current)
			create service_table.make_new_unshared (2)
			service_table.item (0).set_service_name (service.name)
			service_table.item (0).set_lpserviceproc (callback.c_dispatcher)
			debug ("service")
				log ("before start")
			end
			create thread_start_dispatcher.make (service_table)
			--make_application
			run
		rescue
			log ("make rescue")
		end

feature -- Main loop

-- 	main_window: WEL_FRAME_WINDOW is
-- 			-- Need a hwnd, this is it.
-- 			-- 2003-09-25: do I really need it? I think just a thread
-- 			-- message queue is good enough. Does not need to be a
-- 			-- WEL_APPLICATION.
-- 		once
-- 			create Result.make_top ("don't show please")
-- 		end

	run is
		local
			msg: WEL_MSG
			done: BOOLEAN
			i: INTEGER
		do
			debug ("service")
				log ("run begin")
			end
			thread_start_dispatcher.launch
			from
				create msg.make
			until
				done or else
				thread_start_dispatcher.terminated or else
				i > 60
			loop
				msg.peek_all
				if msg.last_boolean_result then
					if msg.quit or else msg.message = WM_ENDSESSION then
						done := True
					else
						msg.translate
						msg.dispatch
					end
				end
				mssleep (1000)
				-- enable to terminate service after 60s, great to avoid
				-- reboots when debugging buggy terminating loops
				--i := i + 1
			end
			mssleep (1000)
			debug ("service")
				log ("run end")
			end
		rescue
			log ("run rescue")
		end


feature {NONE} -- Callback

	dispatch_to_service (arguments: ARRAY [STRING]) is
		do
			service.main (arguments)
		end

	service_main (dwnumservicesargs: INTEGER; lpserviceargvectors: POINTER) is
		do
			-- Dispatch here to proper service based on first string in
			-- `lpserviceargvectors'.
			-- This routine is called in a separate thread, created by the SCM.
			debug ("service")
				log ("ServiceMain begin")
			end
			dispatch_to_service (Void)
			debug ("service")
				log ("ServiceMain end")
			end
		end

	callback: LPSERVICE_MAIN_FUNCTIONA_DISPATCHER

	thread_start_dispatcher: THREAD_START_SERVICE_CTRL_DISPATCHER
			-- Call to StartServiceCtrlDispatcher.


feature {NONE} -- Services

	service: SERVICE
			-- My service, only one supported for now.


feature {NONE} -- Windows messages

	wm_endsession: INTEGER is 0x16


end
