indexing

	description: "Do StartServiceCtrlDispatcher in a separate thread, thanks to Delphi 5 for the idea. StartServiceCtrlDispatcher itself does not return and the handler functions want to execute in the primary thread."


class

	THREAD_START_SERVICE_CTRL_DISPATCHER


inherit

	THREAD
		export
			{ANY} terminated
		end

	SERVICE_DEBUGGING
		export
			{NONE} all
		end

	WEL_APPLICATION_MAIN_WINDOW

	WEL_WINDOW_CONSTANTS

	WINSVC_FUNCTIONS_EXTERNAL
		export
			{NONE} all
		end


creation

	make


feature {NONE} -- Initialization

	make (a_service_table: SERVICE_TABLE_ENTRYA_ARRAY) is
		require
			a_service_table_not_void: a_service_table /= Void
		do
			service_table := a_service_table
		end


feature -- Access

	service_table: SERVICE_TABLE_ENTRYA_ARRAY
			-- Array of SERVICE_TABLE_ENTRYs.


feature -- Execution

	execute is
		local
			r: INTEGER
		do
-- 			debug ("service")
-- 				log ("dispatcher thread id ")
-- 			end
			r := start_service_ctrl_dispatcher_a_external (service_table.array_address)
			-- Borland does this, but do I? I've replaced my main loop, so I just
			-- check terminated.
			--cwin_post_message (application_main_window.item, wm_quit, 0, 0)
			terminated := True
-- 			debug ("service")
-- 				log ("dispatcher thread end")
-- 			end
		end


feature {NONE} -- Windows API

	cwin_post_message (hwnd: POINTER; msg, wparam,
				lparam: INTEGER) is
			-- SDK PostMessage (without the result)
		external
			"C [macro %"wel.h%"] (HWND, UINT, WPARAM, LPARAM)"
		alias
			"PostMessage"
		end


invariant

	service_table_not_void: service_table /= Void

end
